Index: pjproject/trunk/pjsip-apps/build/py_pjsua.dsp
===================================================================
--- pjproject/trunk/pjsip-apps/build/py_pjsua.dsp	(revision 1429)
+++ pjproject/trunk/pjsip-apps/build/py_pjsua.dsp	(revision 1430)
@@ -71,5 +71,5 @@
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PY_PJSUA_EXPORTS" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "..\..\pjlib\include" /I "..\..\pjlib-util\include" /I "..\..\pjmedia\include" /I "..\..\pjsip\include" /I "../../pjnath/include" /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PY_PJSUA_EXPORTS" /FR /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "..\..\pjlib\include" /I "..\..\pjlib-util\include" /I "..\..\pjmedia\include" /I "..\..\pjsip\include" /I "../../pjnath/include" /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PY_PJSUA_EXPORTS" /FR /YX /FD /GZ /c
 # ADD BASE MTL /nologo /D "_DEBUG" /mktyplib203 /win32
 # ADD MTL /nologo /D "_DEBUG" /mktyplib203 /win32
@@ -114,4 +114,8 @@
 
 # PROP Default_Filter "h;hpp;hxx;hm;inl"
+# Begin Source File
+
+SOURCE=..\src\py_pjsua\py_pjsua.h
+# End Source File
 # End Group
 # Begin Group "Resource Files"
Index: pjproject/trunk/pjsip-apps/src/py_pjsua/pjsua_app.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/pjsua_app.py	(revision 1429)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/pjsua_app.py	(revision 1430)
@@ -18,9 +18,12 @@
 
 # STUN config.
-# Set C_STUN_SRV to the address of the STUN server to enable STUN
-#
-C_STUN_SRV = ""
+# Set C_STUN_HOST to the address:port of the STUN server to enable STUN
+#
+#C_STUN_HOST = ""
+C_STUN_HOST = "192.168.0.2"
+#C_STUN_HOST = "stun.iptel.org:3478"
+
+# SIP port
 C_SIP_PORT = 5060
-C_STUN_PORT = 3478
 
 
@@ -41,4 +44,5 @@
 def err_exit(title, rc):
     py_pjsua.perror(THIS_FILE, title, rc)
+    py_pjsua.destroy()
     exit(1)
 
@@ -197,4 +201,8 @@
 	ua_cfg.cb.on_call_transfer_request = on_call_transfer_request
 
+	# Configure STUN setting
+	if C_STUN_HOST != "":
+	    ua_cfg.stun_host = C_STUN_HOST;
+
 	# Create and initialize media config
 	med_cfg = py_pjsua.media_config_default()
@@ -208,17 +216,7 @@
 		err_exit("pjsua init() error", status)
 
-	# Configure STUN config
-	#stun_cfg = py_pjsua.stun_config_default()
-	#stun_cfg.stun_srv1 = C_STUN_SRV
-	#stun_cfg.stun_srv2 = C_STUN_SRV
-	#stun_cfg.stun_port1 = C_STUN_PORT
-	#stun_cfg.stun_port2 = C_STUN_PORT
-
 	# Configure UDP transport config
 	transport_cfg = py_pjsua.transport_config_default()
 	transport_cfg.port = C_SIP_PORT
-	#transport_cfg.stun_config = stun_cfg
-	if C_STUN_SRV != "":
-		transport_cfg.use_stun = 1
 
 	# Create UDP transport
@@ -226,11 +224,10 @@
 	    py_pjsua.transport_create(py_pjsua.PJSIP_TRANSPORT_UDP, transport_cfg)
 	if status != 0:
-		py_pjsua.destroy()
 		err_exit("Error creating UDP transport", status)
+		
 
 	# Create initial default account
 	status, acc_id = py_pjsua.acc_add_local(transport_id, 1)
 	if status != 0:
-		py_pjsua.destroy()
 		err_exit("Error creating account", status)
 
@@ -497,5 +494,4 @@
 	status = py_pjsua.start()
 	if status != 0:
-		py_pjsua.destroy()
 		err_exit("Error starting pjsua!", status)
 
Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1429)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1430)
@@ -17,7 +17,5 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#include <Python.h>
-#include "structmember.h"
-#include <pjsua-lib/pjsua.h>
+#include "py_pjsua.h"
 
 #define THIS_FILE    "main.c"
@@ -61,117 +59,9 @@
 
 
-/*
- * pjsip_event_Object
- * C/python typewrapper for event struct
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pjsip_event * event;
-} pjsip_event_Object;
-
-
-/*
- * pjsip_event_Type
- * event struct signatures
- */
-static PyTypeObject pjsip_event_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                          /*ob_size*/
-    "py_pjsua.PJSIP_Event",     /*tp_name*/
-    sizeof(pjsip_event_Object), /*tp_basicsize*/
-    0,                          /*tp_itemsize*/
-    0,                          /*tp_dealloc*/
-    0,                          /*tp_print*/
-    0,                          /*tp_getattr*/
-    0,                          /*tp_setattr*/
-    0,                          /*tp_compare*/
-    0,                          /*tp_repr*/
-    0,                          /*tp_as_number*/
-    0,                          /*tp_as_sequence*/
-    0,                          /*tp_as_mapping*/
-    0,                          /*tp_hash */
-    0,                          /*tp_call*/
-    0,                          /*tp_str*/
-    0,                          /*tp_getattro*/
-    0,                          /*tp_setattro*/
-    0,                          /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,         /*tp_flags*/
-    "pjsip_event objects",      /*tp_doc */
-};
-
-
-/*
- * pjsip_rx_data_Object
- * C/python typewrapper for RX data struct
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pjsip_rx_data * rdata;
-} pjsip_rx_data_Object;
-
-
-/*
- * pjsip_rx_data_Type
- */
-static PyTypeObject pjsip_rx_data_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.PJSIP_RX_Data",       /*tp_name*/
-    sizeof(pjsip_rx_data_Object),   /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    0,                              /*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "pjsip_rx_data objects",        /*tp_doc*/
-};
-
-
-/*
- * callback_Object
- * C/python typewrapper for callback struct
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    PyObject * on_call_state;
-    PyObject * on_incoming_call;
-    PyObject * on_call_media_state;
-    PyObject * on_call_transfer_request;
-    PyObject * on_call_transfer_status;
-    PyObject * on_call_replace_request;
-    PyObject * on_call_replaced;
-    PyObject * on_reg_state;
-    PyObject * on_buddy_state;
-    PyObject * on_pager;
-    PyObject * on_pager_status;
-    PyObject * on_typing;
-
-} callback_Object;
-
 
 /*
  * The global callback object.
  */
-static callback_Object * g_obj_callback;
+static PyObj_pjsua_callback * g_obj_callback;
 
 
@@ -184,9 +74,9 @@
     if (PyCallable_Check(g_obj_callback->on_call_state))
     {	
-        pjsip_event_Object * obj;
+        PyObj_pjsip_event * obj;
 
 	ENTER_PYTHON();
 
-	obj = (pjsip_event_Object *)PyType_GenericNew(&pjsip_event_Type,
+	obj = (PyObj_pjsip_event *)PyType_GenericNew(&PyTyp_pjsip_event,
 						      NULL, NULL);
 		
@@ -194,5 +84,8 @@
 		
         PyObject_CallFunctionObjArgs(
-            g_obj_callback->on_call_state,Py_BuildValue("i",call_id),obj,NULL
+            g_obj_callback->on_call_state,
+	    Py_BuildValue("i",call_id),
+	    obj,
+	    NULL
         );
 
@@ -211,9 +104,9 @@
     if (PyCallable_Check(g_obj_callback->on_incoming_call))
     {
-	pjsip_rx_data_Object * obj;
+	PyObj_pjsip_rx_data * obj;
 
 	ENTER_PYTHON();
 
-	obj = (pjsip_rx_data_Object *)PyType_GenericNew(&pjsip_rx_data_Type, 
+	obj = (PyObj_pjsip_rx_data *)PyType_GenericNew(&PyTyp_pjsip_rx_data, 
 							NULL, NULL);
 	obj->rdata = rdata;
@@ -242,5 +135,36 @@
 	ENTER_PYTHON();
 
-        PyObject_CallFunction(g_obj_callback->on_call_media_state,"i",call_id);
+        PyObject_CallFunction(
+	    g_obj_callback->on_call_media_state,
+	    "i",
+	    call_id,
+	    NULL
+	);
+
+	LEAVE_PYTHON();
+    }
+}
+
+
+/*
+ * cb_on_dtmf_digit()
+ * Callback from PJSUA-LIB on receiving DTMF digit
+ */
+static void cb_on_dtmf_digit(pjsua_call_id call_id, int digit)
+{
+    if (PyCallable_Check(g_obj_callback->on_call_media_state))
+    {
+	char digit_str[10];
+
+	ENTER_PYTHON();
+
+	pj_ansi_snprintf(digit_str, sizeof(digit_str), "%c", digit);
+
+        PyObject_CallFunctionObjArgs(
+	    g_obj_callback->on_call_media_state,
+	    Py_BuildValue("i",call_id),
+	    PyString_FromString(digit_str),
+	    NULL
+	);
 
 	LEAVE_PYTHON();
@@ -341,9 +265,9 @@
 	PyObject * txt;
 	int cd;
-        pjsip_rx_data_Object * obj;
+        PyObj_pjsip_rx_data * obj;
 
 	ENTER_PYTHON();
 
-	obj = (pjsip_rx_data_Object *)PyType_GenericNew(&pjsip_rx_data_Type,
+	obj = (PyObj_pjsip_rx_data *)PyType_GenericNew(&PyTyp_pjsip_rx_data,
 							NULL, NULL);
         obj->rdata = rdata;
@@ -387,5 +311,5 @@
             g_obj_callback->on_call_replaced,
 	    Py_BuildValue("i",old_call_id),
-	    Py_BuildValue("i",old_call_id),
+	    Py_BuildValue("i",new_call_id),
 	    NULL
         );
@@ -406,5 +330,10 @@
 	ENTER_PYTHON();
 
-        PyObject_CallFunction(g_obj_callback->on_reg_state,"i",acc_id);
+        PyObject_CallFunction(
+	    g_obj_callback->on_reg_state,
+	    "i",
+	    acc_id,
+	    NULL
+	);
 
 	LEAVE_PYTHON();
@@ -423,5 +352,10 @@
 	ENTER_PYTHON();
 
-        PyObject_CallFunction(g_obj_callback->on_buddy_state,"i",buddy_id);
+        PyObject_CallFunction(
+	    g_obj_callback->on_buddy_state,
+	    "i",
+	    buddy_id,
+	    NULL
+	);
 
 	LEAVE_PYTHON();
@@ -447,5 +381,6 @@
             PyString_FromStringAndSize(contact->ptr, contact->slen),
             PyString_FromStringAndSize(mime_type->ptr, mime_type->slen),
-            PyString_FromStringAndSize(body->ptr, body->slen), NULL
+            PyString_FromStringAndSize(body->ptr, body->slen), 
+	    NULL
         );
 
@@ -505,5 +440,6 @@
             PyString_FromStringAndSize(to->ptr, to->slen),
             PyString_FromStringAndSize(contact->ptr, contact->slen),
-            Py_BuildValue("i",is_typing),NULL
+            Py_BuildValue("i",is_typing),
+	    NULL
         );
 
